/**
 * Ext GWT 3.0.0-beta1 - Ext for GWT
 * Copyright(c) 2007-2011, Sencha, Inc.
 * licensing@sencha.com
 *
 * http://sencha.com/license
 */
package com.sencha.gxt.core.client.util;

/**
 * Instances of this class represent a rectangle's size.
 */
public class PreciseSize {

  private double width;
  private double height;

  /**
   * Creates a new size instance.
   * 
   * @param width the width
   * @param height the height
   */
  public PreciseSize(double width, double height) {
    this.width = width;
    this.height = height;
  }

  public String toString() {
    return "height: " + height + ", width: " + width;
  }

  public boolean equals(Object obj) {
    if (obj instanceof PreciseSize) {
      PreciseSize s = (PreciseSize) obj;
      if (width == s.width && height == s.height) {
        return true;
      }
      return false;
    }
    return super.equals(obj);
  }

  public double getWidth() {
    return width;
  }

  public void setWidth(double width) {
    this.width = width;
  }

  public double getHeight() {
    return height;
  }

  public void setHeight(double height) {
    this.height = height;
  }

}
