/**
 * Ext GWT 3.0.0-beta1 - Ext for GWT
 * Copyright(c) 2007-2011, Sencha, Inc.
 * licensing@sencha.com
 *
 * http://sencha.com/license
 */
package com.sencha.gxt.data.shared.event;

import com.google.gwt.event.shared.EventHandler;
import com.google.gwt.event.shared.GwtEvent;
import com.google.gwt.event.shared.HandlerRegistration;
import com.google.gwt.event.shared.HasHandlers;
import com.sencha.gxt.data.shared.event.StoreSortEvent.StoreSortHandler;

public final class StoreSortEvent<M> extends StoreEvent<M, StoreSortHandler<M>> {
  private static GwtEvent.Type<StoreSortHandler<?>> TYPE;

  public static GwtEvent.Type<StoreSortHandler<?>> getType() {
    if (TYPE == null) {
      TYPE = new GwtEvent.Type<StoreSortEvent.StoreSortHandler<?>>();
    }
    return TYPE;
  }

  @SuppressWarnings({"rawtypes", "unchecked"})
  @Override
  public GwtEvent.Type<StoreSortHandler<M>> getAssociatedType() {
    return (GwtEvent.Type) getType();
  }

  @Override
  protected void dispatch(StoreSortHandler<M> handler) {
    handler.onSort(this);
  }

  public interface StoreSortHandler<M> extends EventHandler {
    void onSort(StoreSortEvent<M> event);
  }

  public interface HasStoreSortHandler<M> extends HasHandlers {
    HandlerRegistration addStoreSortHandler(StoreSortHandler<M> handler);
  }
}
