/**
 * Ext GWT 3.0.0-beta1 - Ext for GWT
 * Copyright(c) 2007-2011, Sencha, Inc.
 * licensing@sencha.com
 *
 * http://sencha.com/license
 */
package com.sencha.gxt.data.shared.loader;

import java.util.List;

public class PagingLoadResultBean<Data> extends ListLoadResultBean<Data> implements PagingLoadResult<Data> {

  protected int totalLength;
  protected int offset;
  
  public PagingLoadResultBean() {
    
  }

  /**
   * Creates a new paging list load result.
   * 
   * @param list the data
   * @param totalLength the total length
   * @param offset the paging offset
   */
  public PagingLoadResultBean(List<Data> list, int totalLength, int offset) {
    super(list);
    this.totalLength = totalLength;
    this.offset = offset;
  }

  @Override
  public int getOffset() {
    return offset;
  }

  @Override
  public int getTotalLength() {
    return totalLength;
  }

  @Override
  public void setOffset(int offset) {
    this.offset = offset;
  }

  @Override
  public void setTotalLength(int totalLength) {
    this.totalLength = totalLength;
  }

}
