/**
 * Ext GWT 3.0.0-beta1 - Ext for GWT
 * Copyright(c) 2007-2011, Sencha, Inc.
 * licensing@sencha.com
 *
 * http://sencha.com/license
 */
package com.sencha.gxt.theme.base.client.menu;

import com.google.gwt.resources.client.CssResource;
import com.google.gwt.safehtml.shared.SafeHtmlBuilder;
import com.sencha.gxt.widget.core.client.menu.MenuBar.MenuBarAppearance;

public class MenuBarBaseAppearance implements MenuBarAppearance {

  public interface MenuBarResources {

    MenuBarStyle css();

  }

  public interface MenuBarStyle extends CssResource {

    String menuBar();

  }

  private MenuBarResources resources;

  public MenuBarBaseAppearance(MenuBarResources resources) {
    this.resources = resources;
    resources.css().ensureInjected();
  }

  @Override
  public void render(SafeHtmlBuilder builder) {
    builder.appendHtmlConstant("<div class='" + resources.css().menuBar() + "'></div>");
  }

}
