/**
 * Ext GWT 3.0.0-beta1 - Ext for GWT
 * Copyright(c) 2007-2011, Sencha, Inc.
 * licensing@sencha.com
 *
 * http://sencha.com/license
 */
package com.sencha.gxt.widget.core.client.container;

import com.sencha.gxt.core.client.util.Margins;

public class MarginData implements HasMargins {
  private Margins margins;

  /**
   * Creates a new layout data.
   */
  public MarginData() {
  }

  /**
   * Creates a new layout data.
   * 
   * @param margins the margins
   */
  public MarginData(int margins) {
    this.margins = new Margins(margins);
  }

  /**
   * Creates a new layout data.
   * 
   * @param top the top margin
   * @param right the right margin
   * @param bottom the bottom margin
   * @param left the left margin
   */
  public MarginData(int top, int right, int bottom, int left) {
    this.margins = new Margins(top, right, bottom, left);
  }

  /**
   * Creates a new layout data.
   * 
   * @param margins the margins
   */
  public MarginData(Margins margins) {
    this.margins = margins;
  }

  @Override
  public Margins getMargins() {
    return margins;
  }

  @Override
  public void setMargins(Margins margins) {
    this.margins = margins;

  }

}
