/**
 * Ext GWT 3.0.0-beta1 - Ext for GWT
 * Copyright(c) 2007-2011, Sencha, Inc.
 * licensing@sencha.com
 *
 * http://sencha.com/license
 */
package com.sencha.gxt.widget.core.client.form.validator;

import java.util.List;

import com.google.gwt.editor.client.Editor;
import com.google.gwt.editor.client.EditorError;
import com.sencha.gxt.messages.client.DefaultMessages;
import com.sencha.gxt.widget.core.client.form.error.DefaultEditorError;

public class RegExValidator extends AbstractValidator<String> {

  public interface RegExMessages {
    public String regExMessage();
  }

  protected class DefaultRegExMessages implements RegExMessages {

    @Override
    public String regExMessage() {
      return DefaultMessages.getMessages().textField_regexText();
    }

  }

  protected String regex;
  private RegExMessages messages;

  public RegExValidator(String regex) {
    this.regex = regex;
  }

  public RegExMessages getMessages() {
    if (messages == null) {
      messages = new DefaultRegExMessages();
    }
    return messages;
  }

  public void setMessages(RegExMessages messages) {
    this.messages = messages;
  }

  @Override
  public List<EditorError> validate(Editor<String> field, String value) {
    if (value != null) {
      if (!value.matches(regex)) {
        return createError(new DefaultEditorError(field, getMessages().regExMessage(), value));
      }
    }
    return null;
  }

}
