/**
 * Ext GWT 3.0.0-beta1 - Ext for GWT
 * Copyright(c) 2007-2011, Sencha, Inc.
 * licensing@sencha.com
 *
 * http://sencha.com/license
 */
package com.sencha.gxt.widget.core.client.grid;

import com.google.gwt.i18n.client.NumberFormat;
import com.google.gwt.safehtml.shared.SafeHtml;
import com.google.gwt.safehtml.shared.SafeHtmlUtils;
import com.google.gwt.user.client.ui.IsWidget;
import com.sencha.gxt.core.client.ValueProvider;

public class AggregationNumberSummaryRenderer<M, N> extends AggregationNumberFormatRenderer<M> {
  private final SummaryType<M, N, ? extends Number> summaryType;

  public AggregationNumberSummaryRenderer(NumberFormat format, SummaryType<M, N, ? extends Number> summaryType) {
    super(format);
    this.summaryType = summaryType;
  }

  public AggregationNumberSummaryRenderer(SummaryType<M, N, ? extends Number> summaryType) {
    super();
    this.summaryType = summaryType;
  }

  public SummaryType<M, N, ? extends Number> getSummaryType() {
    return summaryType;
  }

  @Override
  public SafeHtml render(int colIndex, Grid<M> grid) {
    ValueProvider<M, N> v = grid.getColumnModel().getValueProvider(colIndex);
    Number n = summaryType.calculate(grid.getStore().getAll(), v);
    return SafeHtmlUtils.fromString(getFormat().format(n));
  }

  @Override
  public IsWidget renderIsWidget(int colIndex, Grid<M> grid) {
    return null;
  }
}
